
/**********************************************************
*
*     PROYECTO: Ejemplo para resaltar parcialmente el texto
*               mostrado por una celda en un browse 
*
*     ARCHIVO:  Highlight.prg
*
*  Programador: J.A. Diego Kerejeta
*
*       Creado: 30/08/2010
*
******************************************************/

#include "Appevent.ch"
#include "Common.ch"
#include "Gra.ch"
#include "Xbp.ch"

#pragma Library( "XppUi2.lib" )

****************
PROCEDURE AppSys
****************
RETURN

**************
PROCEDURE Main
**************
LOCAL cPath:= StrTran( AppName( .T. ), AppName(), '' )
LOCAL oDlg, oSle, oBrowse, oColumn, oXbp, mp1, mp2, nEvent, nCont, aSize

IF ! Fexists( cPath + 'KK.DBF' )
   DBcreate( 'KK', { { 'DATA', 'C', 20, 0  } } )

   USE ( cPath + 'KK' ) NEW EXCLUSIVE

   FOR nCont:= 1 TO 100
      KK->( DBappend() )
      KK->DATA:= CMonth( date() + nCont * 31 )
      KK->( DBappend() )
      KK->DATA:= CDow( date() + nCont )
   NEXT
   KK->( DBgoTop() )
ELSE
   USE ( cPath + 'KK' ) NEW EXCLUSIVE
ENDIF

oDlg := XbpDialog():new(,,,,, .F. )
   oDlg:taskList                 := .T.
   oDlg:clientSize               := { 400, 300 }
   oDlg:drawingArea:clipChildren := .T.
   oDlg:title                    := 'Test'
   oDlg:create()
   oDlg:drawingArea:setFontCompoundName( '9.Arial' )
   CenterControl( oDlg )
   SetAppWindow( oDlg )

aSize:= oDlg:drawingArea:currentSize()
   aSize[ 2 ]-= 24

oSle:= XbpSle():new( oDlg:drawingArea,, { 0, aSize[ 2 ] }, { aSize[ 1 ], 24 } )
  oSle:keyboard:= {|nk,u,obj| IIF( nK = xbeK_UP .OR. nK = xbeK_DOWN, oBrowse:keyboard( nK ), oBrowse:highlight( obj:editBuffer() ) ) }
  oSle:create()

oBrowse := XbpBrowseHighlight():new( oDlg:drawingArea,, { 0, 0 }, aSize,, .F. )
   oBrowse:skipBlock     := {|n| DbSkipper(n) }
   oBrowse:goTopBlock    := {| | DbGoTop()    }
   oBrowse:goBottomBlock := {| | DbGoBottom() }
   oBrowse:phyPosBlock   := {| | Recno()      }
   oBrowse:posBlock      := {| | DbPosition()    }
   oBrowse:goPosBlock    := {|n| DbGoPosition(n) } 
   oBrowse:lastPosBlock  := {| | 100             }
   oBrowse:firstPosBlock := {| | 0               }
   oBrowse:cursorMode    := XBPBRW_CURSOR_ROW
   oBrowse:create()

oColumn := XbpColumn():new( oBrowse )
   oColumn:drawMode:= XBP_DRAW_OWNER
   oColumn:dataLink:= {|x| KK->DATA }
   oBrowse:addColumn( oColumn )

oBrowse:show()
oDlg:show()
SetAppFocus( oSle )

DO WHILE nEvent <> xbeP_Close
   nEvent := AppEvent( @mp1, @mp2, @oXbp )
   oXbp:handleEvent( nEvent, mp1, mp2 )
ENDDO
QUIT
RETURN

***************************************
CLASS XbpBrowseHighlight FROM XbpBrowse
***************************************
PROTECTED:
   VAR cHighlight

EXPORTED:
   INLINE METHOD destroy
   *********************
      ::cHighlight:= nil
      ::XbpBrowse:destroy()
   RETURN self

   INLINE METHOD init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   *****************************************************************
      ::XbpBrowse:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
         ::drawMode:= XBP_DRAW_OWNER
         ::cHighlight := ''
   RETURN self

   INLINE METHOD create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   *******************************************************************
      ::XbpBrowse:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
         ::childList()[ 4 ]:type := XBPSTATIC_TYPE_TEXT
         ::childList()[ 4 ]:setColorBG( GRA_CLR_WHITE )
         ::childList()[ 4 ]:configure()
   RETURN self

   INLINE METHOD customDrawCell( oPS, aInfo )
   ******************************************
     LOCAL xData, nPos, aRect

*     IF aInfo[ XBP_DRAWINFO_AREA ] = aInfo[ XBP_DRAWINFO_COLUMN ]:dataArea

        xData:= aInfo[ XBP_DRAWINFO_AREA ]:getCell( aInfo[ XBP_DRAWINFO_ITEM ] )

        IF xData <> nil .AND. ( nPos:= At( ::cHighlight, xData ) ) > 0

           oPS:setColor( IIF( aInfo[ XBP_DRAWINFO_STATE ] = XBP_DRAWSTATE_SELECTED, XBPSYSCLR_MENUHILITE, XBPSYSCLR_WINDOWSTATICTEXT ) )

           GraCaptionStr( oPS, aInfo[ XBP_DRAWINFO_RECT ], { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }, xData )
           
           oPS:setColor( GRA_CLR_BLUE )

           IF nPos = 1
              GraCaptionStr( oPS, aInfo[ XBP_DRAWINFO_RECT ], { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }, ::cHighlight )
           ELSE
              aRect:= GraQueryTextBox( oPS, Left( xData, nPos - 1 ) )

              GraCaptionStr( oPS, { aInfo[ XBP_DRAWINFO_RECT, 1 ] + aRect[ 3, 1 ], aInfo[ XBP_DRAWINFO_RECT, 2 ] }, { aInfo[ XBP_DRAWINFO_RECT, 3 ], aInfo[ XBP_DRAWINFO_RECT, 4 ] }, ::cHighlight )
           ENDIF
           RETURN .F.
        ENDIF
*     ENDIF
   RETURN .T.

   INLINE METHOD highlight( cStr )
   *******************************
      ::cHighlight:= cStr
      ::invalidateRect()
   RETURN self
ENDCLASS

